module InfernoAlu (
    input clk,
    input [15:0] a,
    input [15:0] b,

    input [3:0] ctl,

    input ci,
    output reg [15:0] f,

    output reg eq
);

    initial begin
        f <= 16'b0;
    end

    always @(ctl or a or b or ci) begin
        if (ctl == 4'b0000)
            f <= a;
        else if (ctl == 4'b0001)
            f <= a + b + ci;
        else if (ctl == 4'b0010)
            f <= a - b - ci;
        else if (ctl == 4'b0011)
            f <= a & b;
        else if (ctl == 4'b0100)
            f <= a | b;
        else if (ctl == 4'b0101)
            f <= ~(a & b);
        else if (ctl == 4'b0110)
            f <= a + 1;
        else if (ctl == 4'b0111)
            f <= a - 1;
        else if (ctl == 4'b1000)
            f <= a << b;
        else if (ctl == 4'b1001)
            f <= a >> b;
        else if (ctl == 4'b1010)
            f <= b;
        else if (ctl == 4'b1011)
            f <= ~a;
        else if (ctl == 4'b1100)
            f <= a;
        else if (ctl == 4'b1101)
            f <= a;
        else if (ctl == 4'b1110)
            f <= a ^ b;
        else if (ctl == 4'b1111)
            f <= 16'b0;
    end
    
    always @(posedge clk) begin
        eq <= a == 16'b0;
    end
    
endmodule