module InfernoCore (
    input clk,
    input reset,

    input start,

    input [15:0] mr_d,
    output [15:0] ar_q,

    input [15:0] ipx_d,
    output [15:0] opx_q,

    output wire [15:0] sysbus,

    output wr_ram
);
    
    wire [6:0] ir_q;
    wire [6:0] ir_q_in;
    wire [24:0] ctl_in;

    wire eq;

    assign wr_ram = ctl_in[14];

    InfernoExecutionUnit execution_unit (
        .clk(clk),
        .reset(reset),
        .ipx_d(ipx_d),
        .mr_d(mr_d),
        .ar_q(ar_q),
        .opx_q(opx_q),
        .sysbus(sysbus),
        .ctl(ctl_in),
        .ir_q(ir_q_in),
        .eq(eq)
    );

    InfernoController controller (
        .clk(clk),
        .reset(reset),
        .opc(ir_q_in),
        .start(start),
        .ctl(ctl_in),
        .eq(eq)
    );


endmodule