module InfernoMemory (
    input clk,

    output reg [15:0] do,
    input [15:0] di,

    input [15:0] addr,

    input we,

    input p_in,
    input p_clk,
    input p_we
);
    
    reg [15:0] memory [0:(1024 * 64) - 1];

    initial begin
        $readmemh("firmware.hex", memory);
    end


    wire [15:0] p_di;
    wire [15:0] p_addr;

    reg32_shift p (
        .data({p_di, p_addr}),
        .clk(p_clk),
        .din(p_in)
    );


    always @(posedge clk) begin
        if (we) begin
            memory[addr] <= di;
            $display("mem_write: %x <- %x", addr, di);
        end else if (p_we) begin
            memory[p_addr] <= p_di;
            $display("mem_write(p): %x <- %x", p_addr, p_di);
        end
        do <= memory[addr];
    end
endmodule