module demux16_8 (
	output reg [15:0] a, b, c, d, e, f, g, h,
	input [2:0] sel,
	input [15:0] in
);
	always @(*) begin
		case (sel)
			3'd0:
				begin
					a <= in;
					b <= 16'd0;
					c <= 16'd0;
					d <= 16'd0;
					e <= 16'd0;
					f <= 16'd0;
					g <= 16'd0;
					h <= 16'd0;
				end
			3'd1:
				begin
					a <= 16'd0;
					b <= in;
					c <= 16'd0;
					d <= 16'd0;
					e <= 16'd0;
					f <= 16'd0;
					g <= 16'd0;
					h <= 16'd0;
				end
			3'd2:
				begin
					a <= 16'd0;
					b <= 16'd0;
					c <= in;
					d <= 16'd0;
					e <= 16'd0;
					f <= 16'd0;
					g <= 16'd0;
					h <= 16'd0;
				end
			3'd3:
				begin
					a <= 16'd0;
					b <= 16'd0;
					c <= 16'd0;
					d <= in;
					e <= 16'd0;
					f <= 16'd0;
					g <= 16'd0;
					h <= 16'd0;
				end
			3'd4:
				begin
					a <= 16'd0;
					b <= 16'd0;
					c <= 16'd0;
					d <= 16'd0;
					e <= in;
					f <= 16'd0;
					g <= 16'd0;
					h <= 16'd0;
				end
			3'd5:
				begin
					a <= 16'd0;
					b <= 16'd0;
					c <= 16'd0;
					d <= 16'd0;
					e <= 16'd0;
					f <= in;
					g <= 16'd0;
					h <= 16'd0;
				end
			3'd6:
				begin
					a <= 16'd0;
					b <= 16'd0;
					c <= 16'd0;
					d <= 16'd0;
					e <= 16'd0;
					f <= 16'd0;
					g <= in;
					h <= 16'd0;
				end
			3'd7:
				begin
					a <= 16'd0;
					b <= 16'd0;
					c <= 16'd0;
					d <= 16'd0;
					e <= 16'd0;
					f <= 16'd0;
					g <= 16'd0;
					h <= in;
				end
		endcase
	end
endmodule
module demux1_8 (
	output reg [0:0] a, b, c, d, e, f, g, h,
	input [2:0] sel,
	input [0:0] in
);
	always @(*) begin
		case (sel)
			3'd0:
				begin
					a <= in;
					b <= 1'd0;
					c <= 1'd0;
					d <= 1'd0;
					e <= 1'd0;
					f <= 1'd0;
					g <= 1'd0;
					h <= 1'd0;
				end
			3'd1:
				begin
					a <= 1'd0;
					b <= in;
					c <= 1'd0;
					d <= 1'd0;
					e <= 1'd0;
					f <= 1'd0;
					g <= 1'd0;
					h <= 1'd0;
				end
			3'd2:
				begin
					a <= 1'd0;
					b <= 1'd0;
					c <= in;
					d <= 1'd0;
					e <= 1'd0;
					f <= 1'd0;
					g <= 1'd0;
					h <= 1'd0;
				end
			3'd3:
				begin
					a <= 1'd0;
					b <= 1'd0;
					c <= 1'd0;
					d <= in;
					e <= 1'd0;
					f <= 1'd0;
					g <= 1'd0;
					h <= 1'd0;
				end
			3'd4:
				begin
					a <= 1'd0;
					b <= 1'd0;
					c <= 1'd0;
					d <= 1'd0;
					e <= in;
					f <= 1'd0;
					g <= 1'd0;
					h <= 1'd0;
				end
			3'd5:
				begin
					a <= 1'd0;
					b <= 1'd0;
					c <= 1'd0;
					d <= 1'd0;
					e <= 1'd0;
					f <= in;
					g <= 1'd0;
					h <= 1'd0;
				end
			3'd6:
				begin
					a <= 1'd0;
					b <= 1'd0;
					c <= 1'd0;
					d <= 1'd0;
					e <= 1'd0;
					f <= 1'd0;
					g <= in;
					h <= 1'd0;
				end
			3'd7:
				begin
					a <= 1'd0;
					b <= 1'd0;
					c <= 1'd0;
					d <= 1'd0;
					e <= 1'd0;
					f <= 1'd0;
					g <= 1'd0;
					h <= in;
				end
		endcase
	end
endmodule
module demux1_2 (
	output reg [0:0] a, b,
	input [0:0] sel,
	input [0:0] in
);
	always @(*) begin
		case (sel)
			1'd0:
				begin
					a <= in;
					b <= 1'd0;
				end
			1'd1:
				begin
					a <= 1'd0;
					b <= in;
				end
		endcase
	end
endmodule
module mux16_2 (
	input [15:0] a, b,
	input [0:0] sel,
	output reg [15:0] out
);
	always @(*) begin
		case (sel)
			1'd0: out <= a;
			1'd1: out <= b;
		endcase
	end
endmodule
module mux16_4 (
	input [15:0] a, b, c, d,
	input [1:0] sel,
	output reg [15:0] out
);
	always @(*) begin
		case (sel)
			2'd0: out <= a;
			2'd1: out <= b;
			2'd2: out <= c;
			2'd3: out <= d;
		endcase
	end
endmodule
module mux16_8 (
	input [15:0] a, b, c, d, e, f, g, h,
	input [2:0] sel,
	output reg [15:0] out
);
	always @(*) begin
		case (sel)
			3'd0: out <= a;
			3'd1: out <= b;
			3'd2: out <= c;
			3'd3: out <= d;
			3'd4: out <= e;
			3'd5: out <= f;
			3'd6: out <= g;
			3'd7: out <= h;
		endcase
	end
endmodule
module mux3_2 (
	input [2:0] a, b,
	input [0:0] sel,
	output reg [2:0] out
);
	always @(*) begin
		case (sel)
			1'd0: out <= a;
			1'd1: out <= b;
		endcase
	end
endmodule
module reg16_a (
	input clk,
	input reset,
	input ce,
	input [15:0] d,
	output reg [15:0] q
);
	always @(posedge clk or posedge reset) begin
		if (reset)
			q <= 16'd0;
		else if (ce)
			q <= d;
	end
endmodule
module reg3_a (
	input clk,
	input reset,
	input ce,
	input [2:0] d,
	output reg [2:0] q
);
	always @(posedge clk or posedge reset) begin
		if (reset)
			q <= 3'd0;
		else if (ce)
			q <= d;
	end
endmodule
module reg7_a (
	input clk,
	input reset,
	input ce,
	input [6:0] d,
	output reg [6:0] q
);
	always @(posedge clk or posedge reset) begin
		if (reset)
			q <= 7'd0;
		else if (ce)
			q <= d;
	end
endmodule
