module sim;
	reg clk = 0;
	reg reset = 1;
    reg start = 0;
	always #2 clk = !clk;

    reg [15:0] ipx = 0;
    wire [15:0] opx;

    wire rx;
    wire tx;
    assign rx = tx;

    reg p_in = 0;
    reg p_clk = 0;
    reg p_we = 0;

    Inferno soc (
        .clk(clk),
        .reset(reset),
        .opx_q(opx),
        .ipx_d(ipx),
        .start(start),
        .rx(rx),
        .tx(tx)
    );

	initial begin
        $dumpfile("dump.lxt");
        $dumpvars(0, sim);

		// $monitor("r0: %h, r1: %h, r2: %h, r3: %h, out: %h", core.registers[0], core.registers[1], core.registers[2], core.registers[3], out);

        #11 reset = 0;
        #8 start = 1;
        #8 start = 0;
	
        #400000 $finish;
    end
endmodule

