#bankdef memory
{
    #addr 0x00
    #size 0xffff
    #bits 16
    #outp 0
}
#bank memory

#ruledef
{

    nop                         => 0b0000000`7 @ 0b000000000`9
    shr     r{d}, r{a}, r{b}    => 0b0100100`7 @ d`3 @ a`3 @ b`3
    shl     r{d}, r{a}, r{b}    => 0b0101000`7 @ d`3 @ a`3 @ b`3
    dec     r{d}                => 0b0110000`7 @ d`3 @ 0b000`3 @ d`3
    inc     r{d}                => 0b0110100`7 @ d`3 @ 0b000`3 @ d`3
    add     r{d}, r{a}, r{b}    => 0b1000000`7 @ d`3 @ a`3 @ b`3
    sub     r{d}, r{a}, r{b}    => 0b1000100`7 @ d`3 @ a`3 @ b`3
    and     r{d}, r{a}, r{b}    => 0b1001000`7 @ d`3 @ a`3 @ b`3
    or      r{d}, r{a}, r{b}    => 0b1001100`7 @ d`3 @ a`3 @ b`3
    nand    r{d}, r{a}, r{b}    => 0b1010000`7 @ d`3 @ a`3 @ b`3
    mov     r{d}, r{b}          => 0b1010100`7 @ d`3 @ a`3 @ b`3
    clr     r{d}                => 0b1011100`7 @ d`3 @ 0b000`3 @ 0b000`3
    xor     r{d}, r{a}, r{b}    => 0b0101100`7 @ d`3 @ a`3 @ b`3
    not     r{d}                => 0b1100000`7 @ d`3 @ a`3 @ d`3
    in      r{d}                => 0b1100100`7 @ d`3 @ 0b000`3 @ 0b000`3
    out     r{d}                => 0b1101000`7 @ d`3 @ 0b000`3 @ 0b000`3
    hlt                         => 0b1111100`7 @ 0b000000000`9
    ldr     r{d}, {m}           => 0b0000110`7 @ d`3 @ 0b000`3 @ 0b000`3 @ m`16
    str     {m}, r{d}           => 0b0001010`7 @ d`3 @ 0b000`3 @ 0b000`3 @ m`16
    jmp     {m}                 => 0b0010011`7 @ 0b000000000`9 @ m`16
    jz      {m}                 => 0b0011011`7 @ 0b000000000`9 @ m`16

    ldr     r{d}, r{m}          => 0b0000100`7 @ d`3 @ m`3 @ 0b000`3 
    str     r{m}, r{d}          => 0b0001000`7 @ d`3 @ m`3 @ 0b000`3
}

MMIO_UART_CLK = 0xfff0
MMIO_UART_RX = 0xfff1
MMIO_UART_TX = 0xfff2